unit UnidadConfiguracion;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ShlObj, activex, ComCtrls, ShellCtrls,
  FileCtrl;

type
  TformConfiguracion = class(TForm)
    bCancelar: TButton;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    txtRutaExportar: TEdit;
    bSeleccionarRuta: TButton;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    opGuardarNombreFichero: TCheckBox;
    txtBD: TEdit;
    Button2: TButton;
    txtFiltro: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    lInfoTotalFicheros: TLabel;
    lstFicheros: TFileListBox;
    GroupBox4: TGroupBox;
    Label10: TLabel;
    txtFicheroExportar: TEdit;
    Button3: TButton;
    opExportarBD: TCheckBox;
    opExportarFichero: TCheckBox;
    Label11: TLabel;
    txtCaracterSeparador: TComboBox;
    opGuardarNombreFicheroFicheroTexto: TCheckBox;
    opNombreCampos: TCheckBox;
    opGuardarLineaFicheroTexto: TCheckBox;
    opGuardarLineaBD: TCheckBox;
    opReemplazar: TCheckBox;
    procedure bCancelarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bSeleccionarRutaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure txtFiltroExit(Sender: TObject);
    procedure txtRutaExportarExit(Sender: TObject);
    procedure lstFicherosChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formConfiguracion: TformConfiguracion;

implementation

uses UnidadProcedimientos;

{$R *.dfm}

procedure TformConfiguracion.bCancelarClick(Sender: TObject);
begin
  esCadINI('Configuracin', 'Ruta ficheros exportar', txtRutaExportar.Text);
  esBoolINI('Configuracin', 'Guardar nombre fichero en tabla', opGuardarNombreFichero.Checked);
  esCadINI('Configuracin', 'Nombre BD a exportar', txtBD.Text);
  esCadINI('Configuracin', 'Filtro ficheros exportar', txtFiltro.Text);
  esBoolINI('Configuracin', 'Exportar a Base de Datos', opExportarBD.Checked);
  esBoolINI('Configuracin', 'Exportar a Fichero de texto', opExportarFichero.Checked);
  esCadINI('Configuracin', 'Fichero de texto a exportar', txtFicheroExportar.Text);
  esCadINI('Configuracin', 'Carcter separador de columnas', txtCaracterSeparador.Text);
  esBoolINI('Configuracin', 'Guardar nombre fichero en fichero de texto', opGuardarNombreFicheroFicheroTexto.Checked);
  esBoolINI('Configuracin', 'Insertar nombre de los campos en la primera fila', opNombreCampos.Checked);
  esBoolINI('Configuracin', 'Guardar nmero de fila de fichero a exportar Fichero texto', opGuardarLineaFicheroTexto.Checked);
  esBoolINI('Configuracin', 'Guardar nmero de fila de fichero a exportar Base de datos', opGuardarLineaBD.Checked);
  esBoolINI('Configuracin', 'Reemplazar datos anteriores en BD', opReemplazar.Checked);  
  Close;
end;

procedure TformConfiguracion.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TformConfiguracion.bSeleccionarRutaClick(Sender: TObject);
var
  Inf: TBrowseInfo;
  Identificador: PItemIDList;
  Gestor: IMalloc;
  Carpeta: Array[0..MAX_PATH] Of Char;
begin
  With Inf Do
  Begin
    hwndOwner := Handle;
    pidlRoot := Nil;
    pszDisplayName := Carpeta;
    lpszTitle := 'Seleccione la ruta donde se encuentren los ficheros para exportar...';
    ulFlags := BIF_BROWSEINCLUDEFILES;
    lpfn := Nil;
  End;
  Identificador := SHBrowseForFolder(Inf);
  If Identificador <> Nil Then
  Begin
    SHGetPathFromIDList(Identificador, Carpeta);
    SHGetMalloc(Gestor);
    Gestor.Free(Identificador);
    if Carpeta <> '' then
    begin
      txtRutaExportar.Text := Carpeta;
      lstFicheros.Directory := txtRutaExportar.Text;
      lstFicheros.Mask := txtFiltro.Text;
    end;
  end;
end;

procedure TformConfiguracion.FormCreate(Sender: TObject);
begin
  txtRutaExportar.Text := leCadINI('Configuracin', 'Ruta ficheros exportar',
      copy (ExtractFilePath(ParamStr(0)), 0, length(ExtractFilePath(ParamStr(0))) - 1));
  opGuardarNombreFichero.Checked := leBoolINI ('Configuracin',
      'Guardar nombre fichero en tabla', true);
  txtBD.Text := leCadINI('Configuracin', 'Nombre BD a exportar', ExtractFilePath(ParamStr(0)) + 'ExpOptenet.mdb');
  txtFiltro.Text := leCadINI('Configuracin', 'Filtro ficheros exportar', '*.txt');
  opExportarBD.Checked := leBoolINI('Configuracin', 'Exportar a Base de Datos', true);
  opExportarFichero.Checked := leBoolINI('Configuracin', 'Exportar a Fichero de texto', true);
  txtFicheroExportar.Text := leCadINI('Configuracin', 'Fichero de texto a exportar', ExtractFilePath(ParamStr(0)) + 'ExpOptenet.txt');
  txtCaracterSeparador.Text := leCadINI('Configuracin', 'Carcter separador de columnas', 'TABULADOR');
  opGuardarNombreFicheroFicheroTexto.Checked := leBoolINI('Configuracin', 'Guardar nombre fichero en fichero de texto', true);
  opNombreCampos.Checked := leBoolINI('Configuracin', 'Insertar nombre de los campos en la primera fila', true);
  opGuardarLineaFicheroTexto.Checked := leBoolINI('Configuracin', 'Guardar nmero de fila de fichero a exportar Fichero texto', true);
  opGuardarLineaBD.Checked := leBoolINI('Configuracin', 'Guardar nmero de fila de fichero a exportar Base de datos', true);
  opReemplazar.Checked := leBoolINI('Configuracin', 'Reemplazar datos anteriores en BD', true);
  lstFicheros.Mask := txtFiltro.Text;
  lstFicheros.Directory := txtRutaExportar.Text;
  lstFicheros.Refresh;
end;

procedure TformConfiguracion.Button2Click(Sender: TObject);
begin
  SaveDialog1.Filter := 'Microsoft Access (*.mdb)|*.mdb|Todos los ficheros (*.*)|*.*';
  SaveDialog1.Title := 'Base de Datos donde se exportarn los ficheros';
  SaveDialog1.DefaultExt := 'mdb';
  SaveDialog1.FileName := 'ExpOptenet';
  if SaveDialog1.Execute then
    txtBD.Text := SaveDialog1.FileName;
end;

procedure TformConfiguracion.txtFiltroExit(Sender: TObject);
begin
  if txtFiltro.Text = '' then
    txtFiltro.Text := '*.*';
  lstFicheros.Mask := txtFiltro.Text;
end;

procedure TformConfiguracion.txtRutaExportarExit(Sender: TObject);
begin
  lstFicheros.Directory := txtRutaExportar.Text;
end;

procedure TformConfiguracion.lstFicherosChange(Sender: TObject);
begin
  lInfoTotalFicheros.Caption := 'Total ficheros: ' + IntToStr(lstFicheros.Count);
end;

procedure TformConfiguracion.Button3Click(Sender: TObject);
begin
  SaveDialog1.Title := 'Fichero de texto donde se exportarn los ficheros';
  SaveDialog1.Filter := 'Ficheros de texto (*.txt)|*.txt|Todos los ficheros (*.*)|*.*';
  SaveDialog1.DefaultExt := 'txt';
  SaveDialog1.FileName := 'ExpOptenet';
  if SaveDialog1.Execute then
    txtFicheroExportar.Text := SaveDialog1.FileName;
end;

end.
