unit UnidadExportar;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, ComCtrls, DB, KDaoTable, KDaoDataBase, daoapi,StrUtils;

type
  TformExportar = class(TForm)
    bIniciarExportacion: TButton;
    bp: TProgressBar;
    lInfoProgreso: TLabel;
    bCerrar: TButton;
    mResultado: TMemo;
    bpLineas: TProgressBar;
    dBD: TKADaoDatabase;
    tTabla: TKADaoTable;
    bCancelar: TButton;
    tTablaConsulta: TKADaoTable;
    GroupBox1: TGroupBox;
    cfRuta: TLabel;
    cfBD: TLabel;
    cfFichero: TLabel;
    cfFiltro: TLabel;
    lstFicheros: TFileListBox;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure bIniciarExportacionClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bCerrarClick(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
  private
    { Private declarations }
    rutaExportar : string;  //ruta de los ficheros a exportar
    filtro : string;  //filtro para los ficheros a exportar
    GuardarNombreFichero : boolean;  //para guardar nombre de fichero en todas las filas en la BD
    GuardarNombreFicheroFicheroTexto : Boolean; //para guardar nombre de fichero en todas las filas en el fichero de texto
    BD : string;  //ruta y mdb en donde se importarn
    ExportarBD : boolean;  //para importar en MDB directamente
    ExportarFichero : boolean;
    FicheroExportar : string;  //fichero de texto donde se importarn
    CaracterSeparador : string; //carcter separador para fichero de texto (separacin de los campos)
    NombreCampos : boolean;  //para guardar el ttulo de los campos en la primera fila del fichero de texto
    GuardarLineaFicheroTexto : boolean; //para guardar la lnea a la que corresponde en el fichero de Optenet en el fichero de texto
    GuardarLineaBD : boolean; //para guardar la lnea a la que corresponde en el fichero de Optenet en el la BD
    Reemplazar : boolean; //si se ha guardado la lnea y el nombre del fichero slo aadir la lnea si no se ha aadido ya
    cancelar : boolean;
  public
    { Public declarations }
  end;

var
  formExportar: TformExportar;

implementation

uses
  unidadProcedimientos;
{$R *.dfm}

procedure TformExportar.FormCreate(Sender: TObject);
begin
  RutaExportar := leCadINI('Configuracin', 'Ruta ficheros exportar', '');
  GuardarNombreFichero := leBoolINI ('Configuracin',
      'Guardar nombre fichero en tabla', false);
  BD := leCadINI('Configuracin', 'Nombre BD a exportar', '');
  Filtro := leCadINI('Configuracin', 'Filtro ficheros exportar', '');
  lstFicheros.Mask := Filtro;
  lstFicheros.Directory := RutaExportar;
  ExportarBD := leBoolINI('Configuracin', 'Exportar a Base de Datos', true);
  ExportarFichero := leBoolINI('Configuracin', 'Exportar a Fichero de texto', true);
  FicheroExportar := leCadINI('Configuracin', 'Fichero de texto a exportar', ExtractFilePath(ParamStr(0)) + 'ExpMapya.txt');
  CaracterSeparador := leCadINI('Configuracin', 'Carcter separador de columnas', 'TABULADOR');
  NombreCampos :=   leBoolINI('Configuracin', 'Insertar nombre de los campos en la primera fila', true);
  GuardarLineaFicheroTexto :=  leBoolINI('Configuracin', 'Guardar nmero de fila de fichero a exportar Fichero texto', true);
  GuardarLineaBD := leBoolINI('Configuracin', 'Guardar nmero de fila de fichero a exportar Base de datos', true);
  GuardarNombreFicheroFicheroTexto := leBoolINI('Configuracin', 'Guardar nombre fichero en fichero de texto', true);
  Reemplazar := leBoolINI('Configuracin', 'Reemplazar datos anteriores en BD', true);
  if not ExportarBD and Not ExportarFichero then
  begin
    MessageDlg('Antes de iniciar la exportacin debe seleccionar, al menos, ' +
        'un medio de exportacin (fichero de texto  base de datos). ',
        mtWarning, [mbok], 0);
    bIniciarExportacion.Enabled := false;
  end;
  if ExportarFichero and (FicheroExportar = '') then
  begin
    MessageDlg('Antes de iniciar la exportacin a un fichero de texto debe ' +
        'seleccionar la ruta y nombre del mismo.', mtWarning, [mbok], 0);
    bIniciarExportacion.Enabled := false;
  end;

  if ExportarBD and (BD = '') then
  begin
    MessageDlg('Antes de iniciar la exportacin a una base de datos debe ' +
        'seleccionar la ruta y nombre de la misma.', mtWarning, [mbok], 0);
    bIniciarExportacion.Enabled := false;
  end;

  if (rutaExportar = '') or (filtro = '') then
  begin
    MessageDlg('Antes de iniciar la exportacin debe configurar todas ' +
        'las opciones de la aplicacin.', mtWarning, [mbok], 0);
    bIniciarExportacion.Enabled := false;
  end;
  cfRuta.Caption := 'Ruta de los log: ' + rutaExportar;
  cfFiltro.Caption := 'Filtro para log: ' + filtro;
  if ExportarBD then
    cfBD.Caption := 'BD a exportar: ' + BD
  else
    cfBD.Caption := 'BD a exportar: No se exportar a Base de Datos';
  if ExportarFichero then
    cfFichero.Caption := 'Fichero a exportar: ' + FicheroExportar
  else
    cfFichero.Caption := 'Fichero a exportar: No se exportar a fichero de texto';
end;

procedure TformExportar.bIniciarExportacionClick(Sender: TObject);
var
  i, j, k, lineaInicio, lineasError : integer;
  lineasExportadas : Double;
  lineaTemp, lineaDefinitiva : string;
  ip, usuario, grupo, nuevo, url, regla, fecha : string;
  c1, c2, cBloqueo, categoria, tipofichero, dia, hora, host : string;
  mTempSal, mTemp : TStringList;
begin
  lineasExportadas := 0;
  if ExportarFichero then
    if FileExists(FicheroExportar) then
      if MessageDlg('Ya existe el fichero destino: ' + FicheroExportar +
          ' Desea reemplazarlo?', mtConfirmation, [mbyes, mbno], 0) = mrno then
      begin
        lInfoProgreso.Caption := 'Proceso cancelado: debe eliminar/reemplazar el fichero destino.';
        lInfoProgreso.Refresh;
        Exit;
      end;

  if MessageDlg('Se va a iniciar la exportacin de ' + IntToStr(lstFicheros.Count) +
      ' ficheros de la ruta ' + lstFicheros.Directory + chr(13) + chr(13) +
      '   Pulse "Aceptar" para continuar.' + chr(13) +
      '   Pulse "Cancelar" para detener el proceso.',
      mtConfirmation, [mbok, mbcancel], 0) = mrok then
  begin
    mResultado.Clear;
    bp.Min := 0;
    bp.Max := lstFicheros.Count - 1;
    bp.Position := 0;
    bp.Refresh;
    mTempSal := TStringList.Create;
    mTemp := TStringList.Create;
    //si se va a exportar en MDB
    if ExportarBD then
    begin
      tTabla.Close;
      dBD.Close;
      if not FileExists (BD) then
      begin
        if MessageDlg('La base de datos: ' + BD +
          ' debe existir para poder realizar la exportacin Desea ' +
          'crearla ahora?', mtConfirmation, [mbyes, mbno], 0) = mryes then
        begin
          dBD.CreateAccessDatabase(bd);
          dbd.Database := BD;
          dBD.Open;
          dBD.CreateEmptyTable('ExpOptenet');
          tTabla.TableName := 'ExpOptenet';
          tTabla.CreateField('IP', dbText, 255);
          tTabla.CreateField('RESERVADO', dbText, 255);
          tTabla.CreateField('USUARIO', dbText, 255);
          tTabla.CreateField('GRUPO', dbText, 255);
          tTabla.CreateField('FECHA_HORA', dbText, 255);
          tTabla.CreateField('URL', dbText, 255);
          tTabla.CreateField('C1', dbText, 255);
          tTabla.CreateField('C2', dbText, 255);
          tTabla.CreateField('BLOQUEADA', dbText, 255);
          tTabla.CreateField('REGLA', dbText, 255);
          tTabla.CreateField('CATEGORIA', dbText, 255);
          tTabla.CreateField('TIPO', dbText, 255);
          tTabla.CreateField('FICHERO', dbText, 255);
          tTabla.CreateField('LINEA', dbDouble, 255);
          tTabla.CreateField('FECHA',dbDate, 0);
          tTabla.CreateField('HORA', dbDate, 0);
          tTabla.CreateField('HOST', dbText, 255);          
          tTabla.Open;
        end
        else
        begin
          MessageDlg('El proceso ha sido cancelado debido a que no existe la '+
              'base de datos destino de la exportacin.', mtError, [mbok], 0);
          lInfoProgreso.Caption := 'Proceso cancelado: falta la base de datos.';
          lInfoProgreso.Refresh;
          exit;
        end;
      end
      else
      begin
        dBD.Database := BD;
        tTabla.TableName := 'ExpOptenet';
        try
          dBD.Open;
          tTabla.Open;
          if Reemplazar then
          begin
            if (VarIsNull(tTabla.fieldbyname('LINEA').value)) or
                (tTabla.fieldbyname('LINEA').value = 0) or
                (VarIsNull(tTabla.fieldbyname('FICHERO').value)) then
            begin
              MessageDlg('No es posible reemplazar los datos existentes, '+
                  'pues el campo LNEA y FICHERO estn vacos.', mtError, [mbok], 0);
              lInfoProgreso.Caption := 'Proceso cancelado: desmarque la opcin "Reemplazar" en configuracin.';
              lInfoProgreso.Refresh;
              Exit;
            end;
          end;
        except
          raise;
        end;
      end;
    end;

    Screen.Cursor := crHourGlass;
    if CaracterSeparador = 'TABULADOR' then
      CaracterSeparador := chr(9);
    //si es la primera lnea y hay que insertar el nombre de los campos
    if ExportarFichero then
    begin
      if NombreCampos then
      begin
        lineaDefinitiva := 'IP' + CaracterSeparador + 'RESERVADO' + CaracterSeparador +
          'USUARIO' + CaracterSeparador + 'GRUPO' + CaracterSeparador + 'FECHA_HORA' +
          CaracterSeparador + 'URL' + CaracterSeparador + 'C1' + CaracterSeparador +
          'C2' + CaracterSeparador + 'BLOQUEADA' + CaracterSeparador + 'REGLA' +
          CaracterSeparador + 'CATEGORIA' + CaracterSeparador + 'TIPO' +
          CaracterSeparador + 'FECHA' + CaracterSeparador + 'HORA' +
          CaracterSeparador + 'HOST';;
        if GuardarNombreFichero then
          lineaDefinitiva := lineaDefinitiva + CaracterSeparador + 'FICHERO';
        if GuardarLineaFicheroTexto then
          lineaDefinitiva := lineaDefinitiva + CaracterSeparador + 'LINEA';
        mTempSal.Add(lineaDefinitiva);
      end;
    end;
    bCancelar.Enabled := True;
    for i := 0 to lstFicheros.count - 1 do
    begin
      Application.ProcessMessages;
      mTemp.Clear;
      lInfoProgreso.Caption := 'Exportando fichero ' + inttostr(i + 1) + ' de ' +
          IntToStr (lstFicheros.Count) + ' [' + lstFicheros.Items[i] + ']' ;
      lInfoProgreso.Refresh;
      mResultado.Lines.Add(' ********** Exportando fichero ' + lstFicheros.Items[i] + ' **********');
      mTemp.LoadFromFile(lstFicheros.Directory + '\' + lstFicheros.Items[i]);
      //si est activada guardar en BD comprobar si ya se ha cargado el fichero actual

      //Inicio de la exportacin
      bpLineas.Min := 0;
      bpLineas.Max := mTemp.Count;
      tTablaConsulta.Close;
      tTablaConsulta.SQL.Clear;
      tTablaConsulta.SQL.Add('SELECT MAX(LINEA) AS VD FROM EXPOPTENET WHERE FICHERO="' + lstFicheros.Items[i] + '"');
      tTablaConsulta.Open;
      if (varisnull(tTablaConsulta.FieldByName('VD').Value)) or
          (tTablaConsulta.FieldByName('VD').Value = 0) then
        lineaInicio := 0
      else
        lineaInicio := tTablaConsulta.FieldByName('VD').Value;
      for j := lineaInicio to mTemp.count - 1 do
      begin
        lineasExportadas := lineasExportadas + 1;
        Application.ProcessMessages;
        if not cancelar then
        begin
          bpLineas.Position := j;
          lineaTemp := mTemp.Strings[j];
          //Direccin IP
          ip := copy(lineaTemp, 0, pos('[', lineaTemp) - 2);
          if Length(ip) <= 16 then  //comprobacin para no exportar lneas errneas
          begin
            //Campo reservado, Usuario, Grupo y Fecha y hora de acceso
            for k := 0 to 4 do
            begin
              lineaTemp := copy(lineaTemp, pos('[', lineaTemp) + 1, length(lineaTemp));
              if k = 0 then
                nuevo := copy(lineaTemp, 0, pos(']', lineaTemp)-1);
              if k = 1 then
                usuario := copy(lineaTemp, 0, pos(']', lineaTemp)-1);
              if k = 2 then
                grupo := copy(lineaTemp, 0, pos(']', lineaTemp)-1);
              if k = 3 then
                fecha := copy(lineaTemp, 0, pos(']', lineaTemp)-1);
            end;

            //url
            url := copy(lineaTemp, 0, pos(']', lineaTemp) - 1);
            lineaTemp := copy(lineaTemp, pos(']', lineaTemp) + 2, length(lineaTemp));

            //campos de bloqueo
            for k := 0 to 2 do
            begin
              if k = 0 then
                c1 := copy(lineaTemp, 0, pos(' ', lineaTemp) - 1);
              if k = 1 then
                c2 := copy(lineaTemp, 0, pos(' ', lineaTemp) - 1);
              if k = 2 then
                cBloqueo := copy(lineaTemp, 0, pos(' ', lineaTemp) - 1);
              lineaTemp := copy(lineaTemp, pos(' ', lineaTemp) + 1, length(lineaTemp));
            end;

            //Regla  y Categora
            for k := 0 to 1 do
            begin
              lineaTemp := copy(lineaTemp, pos('[', lineaTemp) + 1, length(lineaTemp));
              if k = 0 then
                regla := copy(lineaTemp, 0, pos(']', lineaTemp)-1);
              if k = 1 then
                categoria := copy(lineaTemp, 0, pos(']', lineaTemp)-1);
            end;

            //Tipo de fichero
            tipoFichero := copy(lineaTemp, pos(']', lineaTemp) + 2, length(lineaTemp));

            //separamos la fecha en da y hora
            dia := copy (fecha, 0, pos(':',fecha) - 1);
            hora := copy (fecha,pos(':', fecha) + 1, length(fecha));

            //obtenemos el host a partir de la url
            if Pos('/', AnsiReplaceText(url, '//', '**')) > 0 then
              host := copy(url, 0, pos ('/', AnsiReplaceText(url, '//', '**')) - 1)
            else
              host := url;
            if ExportarFichero then
            begin
              lineaDefinitiva := ip + CaracterSeparador + nuevo + CaracterSeparador +
                  usuario + CaracterSeparador + grupo + CaracterSeparador + fecha +
                  CaracterSeparador + url + CaracterSeparador + c1 + CaracterSeparador +
                  c2 + CaracterSeparador + cBloqueo + CaracterSeparador + regla +
                  CaracterSeparador + categoria + CaracterSeparador + tipofichero +
                  CaracterSeparador + dia + CaracterSeparador + hora +
                  CaracterSeparador + host;
              if GuardarNombreFicheroFicheroTexto then
                lineaDefinitiva := lineaDefinitiva + CaracterSeparador + lstFicheros.Items[i];
              if GuardarLineaFicheroTexto then
                lineaDefinitiva := lineaDefinitiva + CaracterSeparador + inttostr(j);

              //Aadir linea al stringlist de salida
              mTempSal.Add(lineaDefinitiva);
            end;
            if ExportarBD then
            begin
              tTabla.Insert;
              tTabla.FieldByName('IP').Value := ip;
              tTabla.FieldByName('RESERVADO').Value := nuevo;
              tTabla.FieldByName('USUARIO').Value := usuario;
              tTabla.FieldByName('GRUPO').Value := grupo;
              tTabla.FieldByName('FECHA_HORA').Value := fecha;
              tTabla.FieldByName('URL').Value := url;
              tTabla.FieldByName('REGLA').Value := regla;
              tTabla.FieldByName('CATEGORIA').Value := categoria;
              tTabla.FieldByName('TIPO').Value := tipofichero;
              tTabla.FieldByName('C1').Value := c1;
              tTabla.FieldByName('C2').Value := c2;
              tTabla.FieldByName('BLOQUEADA').Value := cBloqueo;
              if pos('Jan', dia) > 0 then
                dia := AnsiReplaceText(dia, 'Jan', 'Ene');
              if pos('Apr', dia) > 0 then
                dia := AnsiReplaceText(dia, 'Apr', 'Abr');
              if pos('Aug', dia) > 0 then
                dia := AnsiReplaceText(dia, 'Aug', 'Ago');
              if pos('Dec', dia) > 0 then
                dia := AnsiReplaceText(dia, 'Dec', 'Dic');
              tTabla.FieldByName('FECHA').Value := dia;
              tTabla.FieldByName('HORA').Value := hora;
              tTabla.FieldByName('HOST').Value := host;
              if GuardarNombreFichero then
                tTabla.FieldByName('FICHERO').Value := lstFicheros.Items[i];
              if GuardarLineaBD then
                tTabla.FieldByName('LINEA').Value := j + 1;
              tTabla.Post;
            end;
          end
          else
          begin
            inc(lineasError);
            mResultado.Lines.Add('Error en exportacin lnea: ' + IntToStr(j) +
                chr(13) + chr(10) + mTemp.Strings[j]);
            tTabla.Insert;
            tTabla.FieldByName('IP').Value := 'ERROR';
            if GuardarNombreFichero then
              tTabla.FieldByName('FICHERO').Value := lstFicheros.Items[i];
            if GuardarLineaBD then
              tTabla.FieldByName('LINEA').Value := j + 1;
            tTabla.Post;
          end;
        end
        else
        begin
          bCancelar.Enabled := false;
          Screen.Cursor := crDefault;
          bp.Position := 0;
          bpLineas.Position := 0;
          tTabla.Close;
          dBD.Close;
          lInfoProgreso.Caption := 'Proceso cancelado por el usuario...';
          mResultado.Lines.Add('');
          mResultado.Lines.Add('');
          mResultado.Lines.Add('Proceso de exportacin cancelado por el usuario.');
          mResultado.Lines.Add('Ficheros exportados: ' + inttostr(i));
          mResultado.Lines.Add('Lneas exportadas: ' + FloatToStr(lineasExportadas));
          MessageDlg('El proceso de exportacin ha sido cancelado.',
            mtWarning, [mbok], 0);
          cancelar := false;
          exit;
        end;
      end;
      bp.Position := i;
      bp.Refresh;
    end;
    if ExportarFichero then
    begin
      lInfoProgreso.Caption := 'Guardando fichero de texto ' + FicheroExportar;
      lInfoProgreso.Refresh;
      mTempSal.SaveToFile(FicheroExportar);
    end;
    tTabla.Close;
    dBD.Close;
    bCancelar.Enabled := false;
    lInfoProgreso.Caption := 'Proceso finalizado correctamente';
    lInfoProgreso.Refresh;
    mResultado.Lines.Add('');
    mResultado.Lines.Add('');
    mResultado.Lines.Add('Proceso de exportacin finalizado correctamente.');
    mResultado.Lines.Add('Ficheros exportados: ' + inttostr(i));
    mResultado.Lines.Add('Lneas exportadas: ' + FloatToStr(lineasExportadas));
    mResultado.Lines.Add('Lneas no exportadas: ' + FloatToStr(lineasError));
    Screen.Cursor := crDefault;
    MessageDlg('El proceso de exportacin ha finalizado correctamente.',
      mtInformation, [mbok], 0);
    bCerrar.SetFocus;
  end;
end;

procedure TformExportar.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TformExportar.bCerrarClick(Sender: TObject);
begin
  Close;
end;

procedure TformExportar.bCancelarClick(Sender: TObject);
begin
  cancelar := true;
end;

end.
